////////////////////////////////////////////////////          
// Türk Bayrağı 
// HAZIRLAYAN ÖĞR. GÖR. UFUK ŞANVER
// 
// YARARLANILAN KAYNAKLAR: 1- PROF.DR. RIFAT YAZICI DERS NOTLARI
// YARARLANILAN KAYNAKLAR: 2- SUMANTA GUHA, COMPUTER GRAPHICS THROUGH OPENGL
// 
////////////////////////////////////////////////////

#include <GL/freeglut.h> 
#include <math.h>
#define PI 3.14159
//const float pi = 3.14159;

const float baykirmizi = 213.0/255;//83-207
const float bayyesil = 43.0/255;//176-87
const float baymavi = 30.0/255;//174-138
// Drawing routine.
float gen = 360.0;
float ww = 0.0;
float wh = 0.0;
float otelex = 0.0;
float oteley = 0.0;

void kesisimbul(float n1,float n2,float m1,float m2,float *xk, float *yk){
	*xk=(n1-n2)/(m2-m1);
	*yk=(m2*n1-m1*n2)/(m2-m1);
}



void drawScene(void)
{
	float kirmizi = 213.0;//83-207
	float yesil = 43.0;//176-87
	float mavi = 30.0;//174-138
	float xmerkez = 200.0;
	float ymerkez = 200.0;
	float yaricap = 100.0;
	float derece = 0.0;
	float artim = 0.25;


	kirmizi = kirmizi / 255;
	yesil = yesil / 255;
	mavi = mavi / 255;
	float noktalaryildiz[6][2];
	float egimler[10];
	float nler[10];
	float xkes[10];
	float ykes[10];
	short sayac=0;
	glClear(GL_COLOR_BUFFER_BIT);

	glColor3f(kirmizi, yesil, mavi);
	
	kirmizi = 1.0;
	yesil = 0.0;
	mavi = 0.0;
	
	glTranslatef(otelex,oteley,0.0);
	
	// BAYRAĞIN DIŞ ÇERÇEVESİ
	glColor3f(baykirmizi, bayyesil, baymavi);
	glBegin(GL_QUADS);
	glVertex3f(100.0, 100.0, 0.0);
	glVertex3f(100.0+gen*1.5, 100.0, 0.0);
	glVertex3f(100.0 + gen * 1.5, 100.0+gen, 0.0);
	glVertex3f(100.0, 100.0 + gen, 0.0);
	
	glEnd();
	glFlush();

	kirmizi = 1.0;
	yesil = 1.0;
	mavi = 1.0;
	xmerkez = 100.0+gen/2;
	ymerkez = 100.0+gen/2;
	yaricap = gen/4;
	
// HİLAL DIŞ ÇEMBER
glColor3f(kirmizi, yesil, mavi);
glBegin(GL_TRIANGLES);

for (derece = 0.0;derece < 360.0;derece = derece + artim) {
	glVertex3f(xmerkez, ymerkez, 0.0);
	glVertex3f(xmerkez + yaricap * cos(derece * PI / 180), ymerkez + yaricap * sin(derece * PI / 180), 0.0);
	glVertex3f(xmerkez + yaricap * cos((derece+artim) * PI / 180), ymerkez + yaricap * sin((derece + artim) * PI / 180), 0.0);
}
glEnd();
glFlush();

kirmizi = 1.0;
yesil = 0.0;
mavi = 0.0;

xmerkez = 100.0+gen/2+gen/16;
ymerkez = 100.0+gen/2;
yaricap = gen*0.2;

// HİLAL İÇ ÇEMBER
glColor3f(baykirmizi, bayyesil, baymavi);
glBegin(GL_TRIANGLES);

for (derece = 0.0;derece < 360.0;derece = derece + artim) {
	glVertex3f(xmerkez, ymerkez, 0.0);
	glVertex3f(xmerkez + yaricap * cos(derece * PI / 180), ymerkez + yaricap * sin(derece * PI / 180), 0.0);
	glVertex3f(xmerkez + yaricap * cos((derece + artim) * PI / 180), ymerkez + yaricap * sin((derece + artim) * PI / 180), 0.0);
}
glEnd();
glFlush();

kirmizi = 1.0;
yesil = 1.0;
mavi = 1.0;
artim=72;

yaricap=gen*0.125;
xmerkez=xmerkez-gen*0.2+gen/3+yaricap;

// YILDIZ İÇİN BEŞGEN ÇİZİM
glColor3f(kirmizi, yesil, mavi);
glBegin(GL_TRIANGLES);
sayac=0;
for (derece = 36.0;derece < 396.0;derece = derece + artim) {
	noktalaryildiz[sayac][0]=xmerkez + yaricap * cos(derece * PI / 180);
	noktalaryildiz[sayac+1][0]=xmerkez + yaricap * cos((derece + artim) * PI / 180);
	noktalaryildiz[sayac][1]=ymerkez + yaricap * sin(derece * PI / 180);
	noktalaryildiz[sayac+1][1]=ymerkez + yaricap * sin((derece + artim) * PI / 180);
	
	glVertex3f(xmerkez, ymerkez, 0.0);
	glVertex3f(noktalaryildiz[sayac][0], noktalaryildiz[sayac][1], 0.0);
	glVertex3f(noktalaryildiz[sayac+1][0], noktalaryildiz[sayac+1][1], 0.0);
	sayac++;
}
glEnd();
glFlush();

// BEŞGENİ YILDIZ HALE GETİRME İÇİN GEREKLİ ARA NOKTALARIN HESABI
egimler[0]=(noktalaryildiz[2][1]-noktalaryildiz[0][1])/(noktalaryildiz[2][0]-noktalaryildiz[0][0]);
nler[0]=noktalaryildiz[2][1]-noktalaryildiz[2][0]*egimler[0];
egimler[1]=(noktalaryildiz[4][1]-noktalaryildiz[1][1])/(noktalaryildiz[4][0]-noktalaryildiz[1][0]);
nler[1]=noktalaryildiz[4][1]-noktalaryildiz[4][0]*egimler[1];
kesisimbul(nler[0],nler[1],egimler[0],egimler[1],&xkes[0], &ykes[0]);

egimler[2]=(noktalaryildiz[3][1]-noktalaryildiz[1][1])/(noktalaryildiz[3][0]-noktalaryildiz[1][0]);
nler[2]=noktalaryildiz[3][1]-noktalaryildiz[3][0]*egimler[2];
egimler[3]=(noktalaryildiz[4][1]-noktalaryildiz[2][1])/(noktalaryildiz[4][0]-noktalaryildiz[2][0]);
nler[3]=noktalaryildiz[4][1]-noktalaryildiz[4][0]*egimler[3];
egimler[4]=(noktalaryildiz[3][1]-noktalaryildiz[0][1])/(noktalaryildiz[3][0]-noktalaryildiz[0][0]);
nler[4]=noktalaryildiz[3][1]-noktalaryildiz[3][0]*egimler[4];

kesisimbul(nler[2],nler[0],egimler[2],egimler[0],&xkes[1], &ykes[1]);
kesisimbul(nler[2],nler[3],egimler[2],egimler[3],&xkes[2], &ykes[2]);
kesisimbul(nler[4],nler[3],egimler[4],egimler[3],&xkes[3], &ykes[3]);
kesisimbul(nler[4],nler[1],egimler[4],egimler[1],&xkes[4], &ykes[4]);

// BEŞGENİ YILDIZ HALE GETİRME ÇİZİM
glColor3f(baykirmizi, bayyesil, baymavi);
glBegin(GL_TRIANGLES);

glVertex3f(noktalaryildiz[0][0],noktalaryildiz[0][1],0.0);
glVertex3f(noktalaryildiz[1][0],noktalaryildiz[1][1],0.0);
glVertex3f(xkes[0],ykes[0],0.0);

glVertex3f(noktalaryildiz[2][0],noktalaryildiz[2][1],0.0);
glVertex3f(noktalaryildiz[1][0],noktalaryildiz[1][1],0.0);
glVertex3f(xkes[1],ykes[1],0.0);

glVertex3f(noktalaryildiz[2][0],noktalaryildiz[2][1],0.0);
glVertex3f(noktalaryildiz[3][0],noktalaryildiz[3][1],0.0);
glVertex3f(xkes[2],ykes[2],0.0);

glVertex3f(noktalaryildiz[4][0],noktalaryildiz[4][1],0.0);
glVertex3f(noktalaryildiz[3][0],noktalaryildiz[3][1],0.0);
glVertex3f(xkes[3],ykes[3],0.0);

glVertex3f(noktalaryildiz[4][0],noktalaryildiz[4][1],0.0);
glVertex3f(noktalaryildiz[0][0],noktalaryildiz[0][1],0.0);
glVertex3f(xkes[4],ykes[4],0.0);

glEnd();
glFlush();


}

// BAŞLANGIÇ
void setup(void)
{
	glClearColor(1.0, 1.0, 1.0, 0.0);
}

// OpenGL window reshape 
void resize(int w, int h)
{
	glViewport(0, 0, w, h);
	ww = w;
	wh = h;
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(0.0, ww, 0.0, wh, -1.0, 1.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

// K KÜÇÜLTÜR B BÜYÜTÜR W-A-S-D İLGİLİ YÖNLERDE HAREKET ETTİRİR
void keyInput(unsigned char key, int x, int y)
{
	switch (key)
	{
		case 66:
		otelex=0.0;
		oteley=0.0;
		gen=gen*1.25;
		glutReshapeFunc(resize);
		glutPostRedisplay();
		break;
		
		case 'K':
		otelex=0.0;
		oteley=0.0;
		gen=gen*0.8;
		glutReshapeFunc(resize);
		glutPostRedisplay();
		break;
		
		case 'S':
		oteley=-25.0;
		otelex=0.0;
		glutReshapeFunc(resize);
		glutPostRedisplay();
		
		break;
		
		case 'W':
		oteley=25.0;
		otelex=0.0;
		glutReshapeFunc(resize);
		glutPostRedisplay();
		
		break;
		
		case 'D':
		otelex=25.0;
		oteley=0.0;
		glutReshapeFunc(resize);
		glutPostRedisplay();
		
		break;
		
		case 'A':
		otelex=-25.0;
		oteley=0.0;
		glutReshapeFunc(resize);
		glutPostRedisplay();
		break;
		
	case 27:
		exit(0);
		break;
	default:
		break;
	}
}

// Main routine.
int main(int argc, char **argv)
{
	glutInit(&argc, argv);

	glutInitContextVersion(4, 3);
	glutInitContextProfile(GLUT_COMPATIBILITY_PROFILE);
	glutInitDisplayMode(GLUT_SINGLE | GLUT_RGBA);
	glutInitWindowSize(800, 800);
	glutInitWindowPosition(0, 0);
	glutCreateWindow("TURK BAYRAGI UYGULAMASI B HARFi BUYUTUR");
	glutDisplayFunc(drawScene);
	glutReshapeFunc(resize);
	glutKeyboardFunc(keyInput);


	setup();

	glutMainLoop();
}